import math
from typing import Callable

from sklearn import metrics

from backend.metric.model import MetricValue


def mse(y, y_pred) -> float:
    return float(metrics.mean_squared_error(y, y_pred))


def rmse(y, y_pred) -> float:
    return float(math.sqrt(metrics.mean_squared_error(y, y_pred)))


def mae(y, y_pred) -> float:
    return float(metrics.mean_absolute_error(y, y_pred))


def rmae(y, y_pred) -> float:
    return float(math.sqrt(metrics.mean_absolute_error(y, y_pred)))


def r2(y, y_pred) -> float:
    return float(metrics.r2_score(y, y_pred))


def get_metric(metric: Callable, y, y_pred) -> MetricValue:
    return MetricValue(metric(y[0], y[1]), metric(y_pred[0], y_pred[1]))
